(_dl_open): Fix a typo.
[glibc.git] / elf / ldd.bash.in
blob7e035455dd22e59cb804ce47775aa7d255b67975
1 #! @BASH@
3 # Copyright (C) 1996, 1997, 1998 Free Software Foundation, Inc.
4 # This file is part of the GNU C Library.
6 # The GNU C Library is free software; you can redistribute it and/or
7 # modify it under the terms of the GNU Library General Public License as
8 # published by the Free Software Foundation; either version 2 of the
9 # License, or (at your option) any later version.
11 # The GNU C Library is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14 # Library General Public License for more details.
16 # You should have received a copy of the GNU Library General Public
17 # License along with the GNU C Library; see the file COPYING.LIB. If not,
18 # write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
19 # Boston, MA 02111-1307, USA.
22 # This is the `ldd' command, which lists what shared libraries are
23 # used by given dynamically-linked executables. It works by invoking the
24 # run-time dynamic linker as a command and setting the environment
25 # variable LD_TRACE_LOADED_OBJECTS to a non-empty value.
27 # We should be able to find the translation right at the beginning.
28 TEXTDOMAIN=libc
29 TEXTDOMAINDIR=@TEXTDOMAINDIR@
31 RTLD=@RTLD@
32 RELOCS=
34 while test $# -gt 0; do
35 case "$1" in
36 --v | --ve | --ver | --vers | --versi | --versio | --version)
37 echo $"ldd (GNU libc) @VERSION@
38 Copyright (C) 1996, 1997 Free Software Foundation, Inc.
39 This is free software; see the source for copying conditions. There is NO
40 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
41 exit 0
43 --h | --he | --hel | --help)
44 echo $"ldd [OPTION]... FILE...
45 --help print this help and exit
46 --version print version information and exit
47 -d, --data-relocs process data relocations
48 -r, --function-relocs process data and function relocations
49 Report bugs using the \`glibcbug' script to <bugs@gnu.ai.mit.edu>."
50 exit 0
52 -d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \
53 --data-rel | --data-relo | --data-reloc | --data-relocs)
54 RELOCS='--data-relocs'
55 shift
57 -r | --f | --fu | --fun | --func | --funct | --functi | --functio | \
58 --function | --function- | --function-r | --function-re | --function-rel | \
59 --function-relo | --function-reloc | --function-relocs)
60 RELOCS='--function-relocs'
61 shift
63 --) # Stop option processing.
64 shift; break
66 -*)
67 echo >&2 $"ldd: unrecognized option" "\`$1'"
68 echo >&2 $"Try \`ldd --help' for more information."
69 exit 1
72 break
74 esac
75 done
77 case $# in
79 echo >&2 $"ldd: missing file arguments"
80 echo >&2 $"Try \`ldd --help' for more information."
81 exit 1
84 # We don't list the file name when there is only one.
85 case "$1" in
86 /*) file="$1"
88 *) file="./$1"
90 esac
91 if test ! -f "$file"; then
92 echo "ldd: ${file}:" $"no such file"
93 exit 1
94 elif test -r "$file"; then
95 test -x "$file" ||
96 echo $"ldd: warning: you do not have execution permission for" "\`$file'"
97 if ${RTLD} --verify "$file"; then
98 LD_TRACE_LOADED_OBJECTS=1 exec ${RTLD} ${RELOCS} "$file" || exit 1
99 else
100 echo $" not a dynamic executable"
101 exit 1
103 else
104 echo $"ldd: error: you do not have read permission for" "\`$file'"
105 exit 1
107 exit
110 set -e # Bail out immediately if ${RTLD} loses on any argument.
111 result=0
112 for file; do
113 echo "${file}:"
114 case "$file" in
115 /*) :
117 *) file="./$file"
119 esac
120 if test ! -f "$file"; then
121 echo "ldd: ${file}:" $"no such file"
122 result=1
123 elif test -r "$file"; then
124 test -x "$file" || echo $"\
125 ldd: warning: you do not have execution permission for" "\`$file'"
126 if ${RTLD} --verify "$file"; then
127 LD_TRACE_LOADED_OBJECTS=1 ${RTLD} ${RELOCS} "$file" || result=1
128 else
129 echo $" not a dynamic executable"
130 result=1
132 else
133 echo $"ldd: error: you do not have read permission for" "\`$file'"
134 result=1
136 done
137 esac
139 exit $result
140 # Local Variables:
141 # mode:ksh
142 # End: